{-|
  This module is intended to be a pretty printer for pepa models.
  It should be updated to use 'Text.PrettyPrint.HughesPJ'
-}
module Language.Pepa.Srmc.Print
    ( hPrintSrmcModel )
where


{- Imported Standard Libraries -}
{- Imported Local Libraries -}
import Language.Pepa.Print
   ( HumanPrint     ( .. ) )
import Language.Pepa.Srmc.Syntax
    ( SrmcModel      ( .. )
    , SrmcDef        ( .. )
    )
import Language.Pepa.Utils
   ( mkCSlist )
{- End of Imports -}



{-|
   The main exported function of this model. 
   Prints an srmc model in a human readable format.
-}
hPrintSrmcModel :: SrmcModel -> String
hPrintSrmcModel (SrmcModel sDefs composition) =
   unlines $ (map hprintServiceDef sDefs)
          ++ ("" : [ hprint composition ] ) 

hprintServiceDef :: SrmcDef -> String
hprintServiceDef (ServiceDef ident sDefs)     =
   unlines $ [ (hprint ident) ++ "::{" ]
          ++ (map hprintServiceDef sDefs)
          ++ [ "}" ]
hprintServiceDef (RateSet ident [ oneRate ])  =
   unwords [ hprint ident
           , "="
           , hprint oneRate
           , ";"
           ]
hprintServiceDef (RateSet ident rates)        =
   unwords [ hprint ident
           , "="
           , "{"
           , mkCSlist $ map hprint rates
           , "}"
           , ";"
           ]
hprintServiceDef (ProcessSet ident [ oneP ] ) =
   unwords [ hprint ident
           , "="
           , hprint oneP
           , ";"
           ]
hprintServiceDef (ProcessSet ident comps)     =
   unwords [ hprint ident
           , "="
           , "{"
           , mkCSlist $ map hprint comps
           , "}"
           , ";"
           ]

