{-|
  This module is a simple module to assist in writing transformations
  in which new names must be produced.
-}
module Language.Pepa.Transform.NameSupply 
    ( NameSupply
    , initialNameSupply
    , getName
    )
where


{-
  I do not know if this will in the end be useful, but for now I will
  leave it here.
@
data Renamer a = Renamer a (Int, String) -- the string is the common prefix/suffix

bindRenamer :: Renamer a -> (a -> Renamer b) -> Renamer b
bindRenamer (Renamer a (i,s)) f =
    Renamer b (i + j, s)
    where Renamer b (j, _) = f a

renamerReturn :: a -> Renamer a
renamerReturn a = Renamer a (0, "")

newName :: Renamer a -> (Renamer a, String)
newName (Renamer a (i, s)) = Renamer a (i + 1, name)
			     where name = s ++ "_" ++ (show i)


instance Monad Renamer where
    (>>=)  = bindRenamer
    return = renamerReturn
@
-}

{-|
  For now we use a simple version courtesy of the book
  Implementing Functional Languages by Simon Peyton-Jones and David Lester
  The type of a name supply is simply an int.
-}
type NameSupply = Int

{-| Initialise a name supply -}
initialNameSupply :: NameSupply
initialNameSupply = 0

{-| Retrieve a new name from a name supply and update the name supply -}
getName :: NameSupply -> String -> (NameSupply, String)
getName nameSupply prefix = 
    (nameSupply + 1, makeName prefix nameSupply)
    

--getNames :: NameSupply -> [String] -> (NameSupply, [String])
--getNames nameSupply prefixes
--    = (nameSupply + length prefixes, 
--       zipWith makeName prefixes [nameSupply..])

{- This should *not* be used outside of 'getName' or 'getNames' -}
makeName :: String -> NameSupply -> String
makeName prefix ns = prefix ++ "_" ++ show ns
